//------------------------------------------------- {COPYRIGHT-TOP-RM}
// Licensed Materials - Property of IBM
//
// "Restricted Materials of IBM"
//
// 5724-C51
//
//  Copyright IBM Corp. 1999,2007 All Rights Reserved.
//
// US Government Users Restricted Rights - Use, duplication or
// disclosure restricted by GSA ADP Schedule Contract with
// IBM Corp.
//------------------------------------------------- {COPYRIGHT-END-RM}
//
// File: archive/scripts/tep_events.js, tbsm_base, tbsm_base31e
// SID: 1.5
// Date Modified: 07/05/02 21:59:39
//
// Module Description:
//   Retrieve events from TEP (TEMS) SOAP Server.
//   This is invoked by TBSM SQL Task "TEP Receive Events..", which is defined via tep_setup SQL stored procedure
//

  if( WScript.Arguments.length < 2 )
  {
    WScript.echo("Require parameters: soap_server soap_alias");
    WScript.Quit(-1);
  }
  var soap_server  = WScript.Arguments(0);
  var soap_alias   = WScript.Arguments(1);

  var verbose      = 0;
  var allevents    = 0;
  for( argnum=2; argnum < WScript.Arguments.length; argnum++ )
  {
    switch( WScript.Arguments(argnum) )
    {
      case "verbose":
      case "debug":
        verbose = 1;
        break;
      case "allevents":
        allevents = 1;
        break;
    }
  }

  var event_cnt     = 0;
  var teps_recycled = 0;
  var HGBLTMSTMP    = "";
  var xmlhttp_e     = WScript.CreateObject("Msxml2.ServerXMLHTTP");
  var xmlhttp_d     = WScript.CreateObject("Msxml2.ServerXMLHTTP");

  var oConn =  WScript.CreateObject("ADODB.Connection");
  var oConn_String = "Server=LocalHost;"
                    +"Database=Object;"
                    +"Trusted_Connection=yes;"
                    +"Application Name=tep_events.js "+soap_server+" "+soap_alias+";";
  var oConn_exec;
  oConn.provider = 'sqloledb'; 

  var config_soap_url    = "";
  var config_soap_hdr    = "";
  var config_enabled     = "";
  var config_tec_events  = "";
  var config_GETEVENT_TIMEOUT   = "";
  var config_GETEVENT_SITNAME   = "";
  var config_GETEVENT_SITSOURCE = "";
  
  var err_code   = -1;
  var err_text   = "";
  var err_detail = config_soap_url;

  // Query tep_config 
  Debug("Querying tep_config ...");
  sql = "EXEC tep_events_config @soap_server='"+soap_server+"', @soap_alias='"+soap_alias+"'";
  oConn_Execute(sql);
  if( !oConn_exec.eof)
  {
    config_soap_url   = new String( oConn_exec(0) );
    config_soap_hdr   = new String( oConn_exec(1) );
    HGBLTMSTMP        = new String( oConn_exec(2) );
    if( allevents == 1 )
    {
      HGBLTMSTMP = "0000000000000000";    
    }
    config_enabled            = new String( oConn_exec(3) );
    config_tec_events         = new String( oConn_exec(4) );
    config_GETEVENT_TIMEOUT   = new String( oConn_exec(5) );
    config_GETEVENT_SITNAME   = new String( oConn_exec(6) );
    config_GETEVENT_SITSOURCE = new String( oConn_exec(7) );

    Debug("config_soap_url          = '"+config_soap_url          +"'");
    Debug("HGBLTMSTMP               = '"+HGBLTMSTMP               +"'");
    Debug("config_enabled           = '"+config_enabled           +"'");
    Debug("config_tec_events        = '"+config_tec_events        +"'");
    Debug("config_GETEVENT_TIMEOUT  = '"+config_GETEVENT_TIMEOUT  +"'");
    Debug("config_GETEVENT_SITNAME  = '"+config_GETEVENT_SITNAME  +"'");
    Debug("config_GETEVENT_SITSOURCE= '"+config_GETEVENT_SITSOURCE+"'");
  }
  else
  {
    err_text = 'Could not read tep_config for soap_server="'+soap_server+'" and soap_alias="'+soap_alias+'"';
  }
  var sql = "EXEC tep_log @proc_name='tep_events.js'"
            +", @log_text='Started "+soap_server+" "+soap_alias+" - "+HGBLTMSTMP+" "+config_soap_url+"'";
  oConn_Execute(sql);

  oConn_Close();

  if( err_text == "" && config_soap_url == "" )
  {
    err_text = 'Could not determine soap_url for soap_server="'+soap_server+'" and soap_alias="'+soap_alias+'"';
  }
  if( err_text == "" && config_enabled == "0" )
  {
    err_text = 'enabled=0 for soap_server="'+soap_server+'" and soap_alias="'+soap_alias+'"';
  }
  if( err_text == "" && config_tec_events == "1" )
  {
    err_text = 'tec_events=1 for soap_server="'+soap_server+'" and soap_alias="'+soap_alias+'"';
  }


  if( err_text == "" )
  {
	var Resolve_timeout = 10 * 1000;
	var Connect_timeout = 10 * 1000;
	var Send_timeout    = config_GETEVENT_TIMEOUT * 1000;
	var Receive_timeout = config_GETEVENT_TIMEOUT * 1000;
	xmlhttp_e.setTimeouts( Resolve_timeout, Connect_timeout, Send_timeout, Receive_timeout);
	xmlhttp_d.setTimeouts( Resolve_timeout, Connect_timeout, Send_timeout, Receive_timeout);

    xmlhttp_e.setOption( 2, 13056 ); //   setOption( SXH_OPTION_IGNORE_SERVER_SSL_CERT_ERROR_FLAGS, SXH_SERVER_CERT_IGNORE_ALL_SERVER_ERRORS  )
    xmlhttp_d.setOption( 2, 13056 ); //   setOption( SXH_OPTION_IGNORE_SERVER_SSL_CERT_ERROR_FLAGS, SXH_SERVER_CERT_IGNORE_ALL_SERVER_ERRORS  )

	SendHeartBeat("Started: "+HGBLTMSTMP);  

	Debug("Querying events ...");
  }
  
  // Get events until we hit an error (eg TEMS is down)
  while( err_text == "" )
  {
    GetEvents();
    
    if( err_code == 12002 || //  e.description == The operation timed out
        err_code == 12152 || //  e.description == The server returned an invalid or unrecognized response
        err_code == 16389 )  //  e.description == Unspecified error 
    {
      err_text = "Timeout code "+err_code+" to "+soap_server+" "+soap_alias+".  Trying again .....";
      Debug(err_text);
      sql = "EXEC tep_log @proc_name='tep_events.js'"
                               +", @log_text='"+err_text+"'"
                               +", @log_detail='"+err_detail+"'"
                               +", @row_count="+event_cnt;
      oConn_Execute(sql);
	  
      err_code   = -1;
      err_text   = "";
      err_detail = config_soap_url;

      // send event to XE, so next GetEvent will not timeout
	  SendHeartBeat("Timeout code "+err_code+": No events received in last "+config_GETEVENT_TIMEOUT+" seconds");  
    }

    oConn_Close(sql);
    
    if( err_text == "" )     // If no errors then
    {
      WScript.Sleep(5000);   //   sleep 5 seconds before querying again i.e. give TEMS a chance to process a burst of events
    }
  }

  

  WScript.Echo(err_text);

  sql = "EXEC tep_log @proc_name='tep_events.js'"
                               +", @log_text='"+err_text+"'"
                               +", @log_detail='"+err_detail+"'";
  oConn_Execute(sql);
  oConn_Close(sql);


  WScript.Quit(err_code)


//-----------------------------------------------------------------------------
function SendHeartBeat( heartbeat_msg )
{
  Debug("SendHeartBeat "+config_GETEVENT_SITNAME+" "+heartbeat_msg);

  var payload = '<CT_Get>'
                +config_soap_hdr
                +"<object>O4SRV.ISITSTSH</object>"
                +"<afilter>HSITNAME;EQ;"+config_GETEVENT_SITNAME+"</afilter>"
                +"<afilter>HORIGINNODE;EQ;"+config_GETEVENT_SITSOURCE+"</afilter>"
                +"</CT_Get>";

  SoapRequest( xmlhttp_e, payload );
  if( err_text != "" )
    return;

  xml_e  = xmlhttp_e.responseXML;
  node_e = xml_e.selectSingleNode("SOAP-ENV:Envelope/SOAP-ENV:Body/SOAP-CHK:Success/TABLE/DATA/ROW/HGBLTMSTMP");
  if( node_e == null )
  {
    teps_recycled = 1; 
    Debug("Previous Heartbeat not found, so TEPS has been recycled");
    sql = "EXEC tep_log @proc_name='tep_events.js'"
                               +", @log_text='Previous heartbeat not found in "+soap_server+" "+soap_alias+".'"
                               +", @log_detail='"+config_soap_url+"'"
                               +", @row_count="+event_cnt;
    oConn_Execute(sql);
  }
  else
  {
    Debug("Previous Heartbeat found "+node_e.text);
  }
  
  // Send new heartbeat
  // NOTE: This is done for two main reasons:
  //         1/ So we can determine if the TEPS has been recycled (above).
  //         2/ To get TEPS to clear previous GetEvents requests that have timed-out (on client side).
  //            i.e. since client timed-out there is still and outstanding SOAP request for
  //            O4SRV.ISITSTSH with a HGBLTMSTMP GT filter.  By sending an event this previous SOAP
  //            request filter is satisfied and TEPS cleans up the SOAP request.  If this is not, done
  //            it is possible the that TEPS http 'active thread queue' will exceed the 8 limit,
  //            and all new SOAP request get put on to the Backlog queue until a new event arrives.
  var payload = '<CT_Alert>'
                +config_soap_hdr
                +"<name>"+config_GETEVENT_SITNAME+"</name>"
                +"<source>"+config_GETEVENT_SITSOURCE+"</source>"
                +"<data>"+heartbeat_msg+"</data>"
                +"</CT_Alert>";

  SoapRequest( xmlhttp_e, payload );
  return;
}

//-----------------------------------------------------------------------------
//  GetEvents:  Query TEMS for events since last time stamp.
//
//              NOTE: In older versions of ITM (pre Fix Pack 4), if there are
//                    no events for TEMS to immediately return,
//                    the request will WAIT for a new event i.e. TEMS will not
//                    reply until a new event comes in, or TEMS is shutdown.
//
//                    From Fix Pack 4.0, the event request will return
//                    immediately, even if there are no events to return.
//                    If no error occured, this script will re-issue the 
//                    request after 5 seconds. Otherwise, the script will
//                    exit and the job will be re-started by the SQL Agent.
//-----------------------------------------------------------------------------
function GetEvents()
{
  var evt_HGBLTMSTMP  = "";
  var evt_HNODE       = "";
  var evt_HDELTASTAT  = "";
  var evt_HSITNAME    = "";
  var evt_HORIGINNODE = "";
  var evt_ATOMIZE     = "";
  var evt_HLCLTMSTMP  = "";
  var evt_detail      = "";
  var GMT_index;
  var GMT;

  var payload = '<CT_Get>'
                +config_soap_hdr
                +"<object>O4SRV.ISITSTSH</object>"
                +"<afilter>HGBLTMSTMP;GT;"+HGBLTMSTMP+"</afilter>"
                +"</CT_Get>";

  Debug("GetEvents "+config_soap_url+" "+HGBLTMSTMP);

  SoapRequest( xmlhttp_e, payload );
  if( err_text != "" )
    return;

  xml_e  = xmlhttp_e.responseXML;
  rows_e = xml_e.selectNodes("SOAP-ENV:Envelope/SOAP-ENV:Body/SOAP-CHK:Success/TABLE/DATA/ROW");
  for(node_e = rows_e.nextNode(); node_e != null; node_e = rows_e.nextNode())
  {
    event_cnt++;
    evt_HGBLTMSTMP  = node_e.selectSingleNode("HGBLTMSTMP").text;
    evt_HNODE       = node_e.selectSingleNode("HNODE").text;
    evt_HDELTASTAT  = node_e.selectSingleNode("HDELTASTAT").text;
    evt_HSITNAME    = node_e.selectSingleNode("HSITNAME").text
    evt_HORIGINNODE = node_e.selectSingleNode("HORIGINNODE").text;
    evt_ATOMIZE     = node_e.selectSingleNode("ATOMIZE").text;
    evt_HLCLTMSTMP  = node_e.selectSingleNode("HLCLTMSTMP").text;
	evt_detail      = "";
	
    if( HGBLTMSTMP == "" || HGBLTMSTMP < evt_HGBLTMSTMP)
    {
      HGBLTMSTMP = evt_HGBLTMSTMP;
    }

	if( teps_recycled == 1 )                      // If TEPS has been recycled Then 
	{
		teps_recycled = 0;
		sql = "EXEC tep_event "
                  +   "@soap_url='"   +config_soap_url +"'"
                  + ", @HGBLTMSTMP='" +evt_HGBLTMSTMP  +"'"
                  + ", @HNODE='"      +evt_HNODE       +"'"
                  + ", @HSITNAME='"   +"%"             +"'"
                  + ", @HORIGINNODE='"+""              +"'"
                  + ", @ATOMIZE='"    +""              +"'"
                  + ", @HLCLTMSTMP='" +evt_HLCLTMSTMP  +"'"
                  + ", @HDELTASTAT='" +"P"             +"'"   // reset all previous from this Hub CMS
                  + ", @detail='"     +""              +"'";
		oConn_Execute(sql);
	}
		
    if( evt_HSITNAME != config_GETEVENT_SITNAME )  // If not heartbeat echo
    {
		switch( evt_HDELTASTAT )
		{
		case 'Y':   // Raised
		case 'A':   // Acknowledged
			evt_detail = GetEventDetail( evt_HGBLTMSTMP, evt_HSITNAME, evt_HORIGINNODE);
			break;
		case 'E':   // Resurfaced
		case 'F':   // Expired
			evt_detail = GetEventDetail( evt_HGBLTMSTMP, evt_HSITNAME, evt_HORIGINNODE);
			GMT_index = evt_detail.indexOf(";GTM=")
			if( GMT_index >= 0 )
			{
				GMT_index += 5; // after ";GTM="
				GMT = evt_detail.substr(GMT_index,16);
				Debug("Retrieving original event details for GMT "+GMT);
				evt_detail = GetEventDetail( GMT, evt_HSITNAME, evt_HORIGINNODE );
			}
			break;
		default:
			evt_detail = "";
			break;
		}
		
		sql = "EXEC tep_event "
                  +   "@soap_url='"   +config_soap_url +"'"
                  + ", @HGBLTMSTMP='" +evt_HGBLTMSTMP  +"'"
                  + ", @HNODE='"      +evt_HNODE       +"'"
                  + ", @HSITNAME='"   +evt_HSITNAME    +"'"
                  + ", @HORIGINNODE='"+evt_HORIGINNODE +"'"
                  + ", @ATOMIZE='"    +evt_ATOMIZE     +"'"
                  + ", @HLCLTMSTMP='" +evt_HLCLTMSTMP  +"'"
                  + ", @HDELTASTAT='" +evt_HDELTASTAT  +"'"
                  + ", @detail='"     +evt_detail      +"'";
		oConn_Execute(sql);

	}   // end if evt_HSITNAME != config_GETEVENT_SITNAME

  }  // loop back for next event received

  if( evt_HGBLTMSTMP == "" )
  {
    WScript.echo("No events found in response - "+config_soap_url);

    if ( xmlhttp_e.responseXML.parseError.errorCode != 0 ) 
    {
       err_text = xmlhttp_e.responseXML.parseError.reason;
       Debug(err_text);
    }

    Debug(xmlhttp_e.responseText);
    return;
  }

  Debug("");

}  // end function GetEvents()



//-----------------------------------------------------------------------------
function GetEventDetail( HGBLTMSTMP, HSITNAME, HORIGINNODE )
{
  var evt_detail = "";

  var payload = '<CT_Get>'
                +config_soap_hdr
                +"<object>Status_History</object>"
                +"<afilter>Global_Timestamp;EQ;"+HGBLTMSTMP+"</afilter>"
                +"<afilter>Situation_Name;EQ;"+HSITNAME+"</afilter>"
                +"<afilter>Managed_System;EQ;"+HORIGINNODE+"</afilter>"
                +"<attribute>Results</attribute>"
                +"</CT_Get>";

  Debug("GetDetailEvents "+config_soap_url+" "+HGBLTMSTMP+" "+HSITNAME+" "+HORIGINNODE);
  
  SoapRequest( xmlhttp_d, payload );
  if( err_text != "" )
    return "";

  xml_d  = xmlhttp_d.responseXML;
  node_d = xml_d.selectSingleNode("//Results");
  if( node_d != undefined )
  {
    evt_detail = node_d.text.replace(/'/g,"''");
  }
  
  return evt_detail;

}  // end function GetDetailEvents()


//--------------------------------------------------------
function SoapRequest( xmlhttp, payload )
{
  err_text = "";
  xmlhttp.open("POST", config_soap_url, false);

  xmlhttp.setRequestHeader("MethodName",    "CT_Get"   )
  xmlhttp.setRequestHeader("InterfaceName", "CT_SOAP"  )
  xmlhttp.setRequestHeader("MessageType",   "Call"     )
  xmlhttp.setRequestHeader("Content-Type",  "text/xml" )

  try
  {
    xmlhttp.send(payload);
  }
  catch(e)
  {
    err_code = (e.number & 0xFFFF);
    err_text = "Error for send: "+err_code+" - "+e.description;
  }

  if( err_text != "" )
    return;

  if( xmlhttp.status != 200) // If not OK
  {
    err_code   = xmlhttp.status
    err_text   = "Error for receive: "+xmlhttp.status+" - "+xmlhttp.statusText+" - "+config_soap_url
    err_detail = xmlhttp.responseText;
    return;
  }

  xmlo = xmlhttp.responseXML;
//Debug(xmlhttp.responseText);

  var faultstring = xmlo.selectSingleNode("//faultstring");
  if (faultstring != undefined)
  {
    err_text = "faultstring: "+faultstring.text
    return;
  }

}


//--------------------------------------------------------
function Debug(msg)
{
  if( verbose != 0 ) 
  {
    WScript.echo(getDateTime()+":  "+msg);
  }
}

function oConn_Open()
{
  if( oConn.State == 0 ) 
  {
    oConn.Open(oConn_String);
  }
}

function oConn_Execute( sql )
{
  Debug("oConn_Execute: "+sql);

  oConn_Open();
  oConn_exec = oConn.Execute(sql);
}

function oConn_Close()
{
  if( oConn.State != 0 ) 
  {
    oConn.Close();
  }
}

function getDateTime() 
{
  var date      = new Date;
  var endYear   = date.getFullYear();
  var endMon    = date.getMonth() + 1;
  var endDay    = date.getDate(); 
  var endHour   = date.getHours();
  var endMinute = date.getMinutes();
  var endSecond = date.getSeconds();

  var endTime = endYear   < 100 ? "0" + endYear   : "" + endYear;
  endTime    += "-";                          
  endTime    += endMon    < 10  ? "0" + endMon    : endMon;
  endTime    += "-";                          
  endTime    += endDay    < 10  ? "0" + endDay    : endDay;
  endTime    += " ";                          
  endTime    += endHour   < 10  ? "0" + endHour   : endHour;
  endTime    += ":";                          
  endTime    += endMinute < 10  ? "0" + endMinute : endMinute;
  endTime    += ":";                          
  endTime    += endSecond < 10  ? "0" + endSecond : endSecond;

  return endTime;
}

